package ui.view;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JCheckBox;
import javax.swing.LayoutStyle.ComponentPlacement;
import java.awt.Color;
import javax.swing.SwingConstants;

import ui.controller.Control;
import ui.model.Model;

import javax.swing.JComboBox;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class StatisticPane extends JPanel{
	private JScrollPane listScrollPane = new JScrollPane();
    private JList objectList;
    private DefaultListModel listModel =  new DefaultListModel();
    private Model model;
    private Control controller;
    //private StatisticGraph statGraph;
    private JPanel statGraph;
    
    public StatisticPane(Model m, Control c){
    	model = m;
    	controller = c;
    	objectList = new JList(listModel);
    	listScrollPane.setViewportView(objectList);
    	
    	JLabel lblOverallStatistics = new JLabel("Overall Statistics:");
    	lblOverallStatistics.setFont(new Font("Tahoma", Font.PLAIN, 13));
    	
    	JCheckBox chckbxNewCheckBox = new JCheckBox("total consumption");
    	chckbxNewCheckBox.setForeground(Color.RED);
    	
    	JCheckBox chckbxNewCheckBox_1 = new JCheckBox("total production");
    	chckbxNewCheckBox_1.setForeground(Color.BLUE);
    	
    	JLabel lblObject = new JLabel("Object:");
    	lblObject.setFont(new Font("Tahoma", Font.PLAIN, 13));
    	
    	JLabel lblName = new JLabel("Name:");
    	
    	JLabel lblNewLabel = new JLabel("...");
    	lblNewLabel.setHorizontalAlignment(SwingConstants.CENTER);
    	
    	JCheckBox checkBox = new JCheckBox("total consumption");
    	checkBox.setForeground(Color.RED);
    	
    	JCheckBox checkBox_1 = new JCheckBox("total production");
    	checkBox_1.setForeground(Color.BLUE);
    	
    	JLabel lblGraph = new JLabel("  Graph:");
    	
    	JComboBox comboBox = new JComboBox();
    	
    	//statGraph = new StatisticGraph(model, controller);
    	statGraph = new JPanel();
    	
    	JButton btnRefresh = new JButton("Refresh Tracked Objects");
    	btnRefresh.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e) {
    			listModel.removeAllElements();
    			for(int i = 0; i < controller.getTrackingObj().size(); i++){
    				listModel.addElement(controller.getTrackingObj().get(i).getName() +
    						controller.getTrackingObj().get(i).getID());
    			}
    		}
    	});
    	
    	JPanel panel = new JPanel();
    	GroupLayout groupLayout = new GroupLayout(this);
    	groupLayout.setHorizontalGroup(
    		groupLayout.createParallelGroup(Alignment.LEADING)
    			.addGroup(groupLayout.createSequentialGroup()
    				.addContainerGap()
    				.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    					.addGroup(groupLayout.createSequentialGroup()
    						.addComponent(listScrollPane, GroupLayout.PREFERRED_SIZE, 177, GroupLayout.PREFERRED_SIZE)
    						.addGap(263))
    					.addGroup(groupLayout.createSequentialGroup()
    						.addComponent(lblObject, GroupLayout.PREFERRED_SIZE, 56, GroupLayout.PREFERRED_SIZE)
    						.addContainerGap(384, Short.MAX_VALUE))
    					.addGroup(groupLayout.createSequentialGroup()
    						.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    							.addGroup(groupLayout.createSequentialGroup()
    								.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    									.addGroup(groupLayout.createSequentialGroup()
    										.addGap(10)
    										.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    											.addGroup(groupLayout.createSequentialGroup()
    												.addComponent(lblGraph, GroupLayout.PREFERRED_SIZE, 54, GroupLayout.PREFERRED_SIZE)
    												.addPreferredGap(ComponentPlacement.RELATED)
    												.addComponent(comboBox, 0, 127, Short.MAX_VALUE))
    											.addComponent(checkBox_1, GroupLayout.PREFERRED_SIZE, 101, GroupLayout.PREFERRED_SIZE)
    											.addComponent(checkBox, GroupLayout.PREFERRED_SIZE, 111, GroupLayout.PREFERRED_SIZE)
    											.addGroup(groupLayout.createSequentialGroup()
    												.addComponent(lblName)
    												.addPreferredGap(ComponentPlacement.RELATED)
    												.addComponent(lblNewLabel, GroupLayout.PREFERRED_SIZE, 107, GroupLayout.PREFERRED_SIZE))))
    									.addGroup(groupLayout.createSequentialGroup()
    										.addGap(10)
    										.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    											.addComponent(chckbxNewCheckBox)
    											.addComponent(chckbxNewCheckBox_1))
    										.addGap(35)))
    								.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    							.addGroup(groupLayout.createSequentialGroup()
    								.addComponent(lblOverallStatistics, GroupLayout.PREFERRED_SIZE, 126, GroupLayout.PREFERRED_SIZE)
    								.addPreferredGap(ComponentPlacement.RELATED))
    							.addGroup(groupLayout.createSequentialGroup()
    								.addComponent(btnRefresh)
    								.addGap(63)))
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    							.addComponent(panel, GroupLayout.DEFAULT_SIZE, 226, Short.MAX_VALUE)
    							.addComponent(statGraph, GroupLayout.PREFERRED_SIZE, 226, GroupLayout.PREFERRED_SIZE)))))
    	);
    	groupLayout.setVerticalGroup(
    		groupLayout.createParallelGroup(Alignment.LEADING)
    			.addGroup(groupLayout.createSequentialGroup()
    				.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    					.addGroup(groupLayout.createSequentialGroup()
    						.addGap(63)
    						.addComponent(lblOverallStatistics)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(chckbxNewCheckBox)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(chckbxNewCheckBox_1)
    						.addGap(48)
    						.addComponent(lblObject)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
    							.addComponent(lblName)
    							.addComponent(lblNewLabel)))
    					.addGroup(groupLayout.createSequentialGroup()
    						.addGap(17)
    						.addComponent(statGraph, GroupLayout.PREFERRED_SIZE, 140, GroupLayout.PREFERRED_SIZE)))
    				.addGroup(groupLayout.createParallelGroup(Alignment.LEADING)
    					.addGroup(groupLayout.createSequentialGroup()
    						.addGap(80)
    						.addComponent(checkBox)
    						.addPreferredGap(ComponentPlacement.UNRELATED)
    						.addComponent(checkBox_1))
    					.addGroup(Alignment.TRAILING, groupLayout.createSequentialGroup()
    						.addPreferredGap(ComponentPlacement.RELATED)
    						.addComponent(panel, GroupLayout.PREFERRED_SIZE, 123, GroupLayout.PREFERRED_SIZE)))
    				.addPreferredGap(ComponentPlacement.UNRELATED)
    				.addGroup(groupLayout.createParallelGroup(Alignment.BASELINE)
    					.addComponent(lblGraph)
    					.addComponent(comboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
    				.addGap(27)
    				.addComponent(btnRefresh)
    				.addPreferredGap(ComponentPlacement.RELATED)
    				.addComponent(listScrollPane, GroupLayout.PREFERRED_SIZE, 206, GroupLayout.PREFERRED_SIZE)
    				.addContainerGap(91, Short.MAX_VALUE))
    	);
    	setLayout(groupLayout);

    }
    
    public void updateGraphs(){
    	statGraph.repaint();
    }
}
